=== debian/changelog ===
soapyhydrasdr (0.1.0-2) unstable; urgency=medium

  * upload to unstable
  * fix Vcs-* URLs
  * watch version 5

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 03 Nov 2025 18:25:00 -0500

soapyhydrasdr (0.1.0-1) experimental; urgency=medium

  * Package for Debian (Closes: #1114944)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 20 Oct 2025 11:44:30 -0400

soapyhydrasdr (0.1.0-0.1) unstable; urgency=low

  * Release 0.1.0 (2025-06-14)

 -- PE0SAT Jan van Gils <janvgils@hotmail.com>  Sat, 14 Jul 2025 10:42:53 -0000
