=== debian/control ===
Source: soapyhydrasdr
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
	       debhelper-compat (=13),
	       libsoapysdr-dev,
	       libhydrasdr-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/hydrasdr/SoapyHydraSDR
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyhydrasdr.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyhydrasdr

Package: soapysdr0.8-module-hydrasdr
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: HydraSDR device support for SoapySDR
 The Soapy HydraSDR project provides a SoapySDR hardware support module.
 .
 Adds HydraSDR RFOne software defined radio support via Soapy.

Package: soapysdr-module-hydrasdr
Architecture: all
Depends: soapysdr0.8-module-hydrasdr, ${misc:Depends}
Description: HydraSDR device support for SoapySDR (default version)
 The Soapy HydraSDR project provides a SoapySDR hardware support module.
 .
 This is an empty dependency package that pulls in the HydraSDR module
 for the default version of libsoapysdr.
