=== debian/watch ===
Version: 5
Template: GitHub
Owner: hydrasdr
Project: SoapyHydraSDR
