## soapyhydrasdr 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 3.10)
 
 # Project version - UPDATE THIS FOR RELEASES
-set(SOAPYHYDRASDR_VERSION "1.0.0")
+set(SOAPYHYDRASDR_VERSION "1.0.1")
 
 project(SoapyHydraSDR VERSION ${SOAPYHYDRASDR_VERSION} LANGUAGES CXX)
 
@@ -36,18 +36,7 @@
 
 # Ensure SoapySDR module directory is set
 if(NOT SOAPY_SDR_MODULE_DIR)
-	# Extract SoapySDR ABI version from full version
-	if(SoapySDR_VERSION)
-		string(REGEX MATCH "^([0-9]+\\.[0-9]+)" SoapySDR_ABI_VERSION "${SoapySDR_VERSION}")
-		message(STATUS "Extracted SoapySDR ABI version: ${SoapySDR_ABI_VERSION}")
-	endif()
-	
-	if(NOT SoapySDR_ABI_VERSION)
-		set(SoapySDR_ABI_VERSION "0.8")  # Fallback version
-		message(STATUS "Using fallback SoapySDR ABI version: ${SoapySDR_ABI_VERSION}")
-	endif()
-	
-	# Try to detect SoapySDR module directory using pkg-config
+	# Try to detect SoapySDR module directory using pkg-config first (most reliable)
 	find_package(PkgConfig QUIET)
 	if(PKG_CONFIG_FOUND)
 		pkg_check_modules(SOAPYSDR_PC QUIET SoapySDR)
@@ -58,35 +47,107 @@
 				OUTPUT_STRIP_TRAILING_WHITESPACE
 				ERROR_QUIET
 			)
-		endif()
-	endif()
-	
-	# Fallback to common locations if still not found
+			if(SOAPY_SDR_MODULE_DIR)
+				message(STATUS "Detected SoapySDR module directory via pkg-config: ${SOAPY_SDR_MODULE_DIR}")
+			endif()
+		endif()
+	endif()
+
+	# Extract SoapySDR ABI version from module directory or version string
+	if(SOAPY_SDR_MODULE_DIR)
+		# Extract ABI version from the detected module path (e.g., modules0.8-3 -> 0.8-3)
+		string(REGEX MATCH "modules([0-9]+\\.[0-9]+(-[0-9]+)?)" _match "${SOAPY_SDR_MODULE_DIR}")
+		if(_match)
+			set(SoapySDR_ABI_VERSION "${CMAKE_MATCH_1}")
+			message(STATUS "Extracted SoapySDR ABI version from module path: ${SoapySDR_ABI_VERSION}")
+		endif()
+	endif()
+
+	# Fallback: extract ABI version from SoapySDR version string
+	if(NOT SoapySDR_ABI_VERSION AND SoapySDR_VERSION)
+		# For SoapySDR 0.8.x, the ABI version is "0.8-3" for source builds
+		# For SoapySDR 0.8.0 from packages, the ABI version is "0.8"
+		string(REGEX MATCH "^([0-9]+)\\.([0-9]+)\\.([0-9]+)" _version_match "${SoapySDR_VERSION}")
+		if(_version_match)
+			set(_major "${CMAKE_MATCH_1}")
+			set(_minor "${CMAKE_MATCH_2}")
+			set(_patch "${CMAKE_MATCH_3}")
+			# SoapySDR 0.8.1+ uses ABI 0.8-3
+			if("${_major}.${_minor}" STREQUAL "0.8" AND _patch GREATER 0)
+				set(SoapySDR_ABI_VERSION "0.8-3")
+			else()
+				set(SoapySDR_ABI_VERSION "${_major}.${_minor}")
+			endif()
+			message(STATUS "Determined SoapySDR ABI version from version ${SoapySDR_VERSION}: ${SoapySDR_ABI_VERSION}")
+		else()
+			# Simple major.minor extraction as last resort
+			string(REGEX MATCH "^([0-9]+\\.[0-9]+)" SoapySDR_ABI_VERSION "${SoapySDR_VERSION}")
+			message(STATUS "Extracted SoapySDR ABI version: ${SoapySDR_ABI_VERSION}")
+		endif()
+	endif()
+
+	if(NOT SoapySDR_ABI_VERSION)
+		set(SoapySDR_ABI_VERSION "0.8")  # Fallback version
+		message(STATUS "Using fallback SoapySDR ABI version: ${SoapySDR_ABI_VERSION}")
+	endif()
+
+	# Fallback to common locations if module directory not found via pkg-config
 	if(NOT SOAPY_SDR_MODULE_DIR)
 		if(WIN32)
-			set(SOAPY_SDR_MODULE_DIR "lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
+			# Windows with vcpkg - try to find existing module directory
+			# vcpkg typically uses modules0.8 even for SoapySDR 0.8.1+
+			foreach(POSSIBLE_ABI "0.8" "0.8-3" "${SoapySDR_ABI_VERSION}")
+				set(_test_dir "${CMAKE_PREFIX_PATH}/lib/SoapySDR/modules${POSSIBLE_ABI}")
+				if(EXISTS "${_test_dir}")
+					set(SOAPY_SDR_MODULE_DIR "${_test_dir}")
+					set(SoapySDR_ABI_VERSION "${POSSIBLE_ABI}")
+					message(STATUS "Found Windows SoapySDR module directory: ${SOAPY_SDR_MODULE_DIR}")
+					break()
+				endif()
+			endforeach()
+			# Fallback to relative path with detected ABI version
+			if(NOT SOAPY_SDR_MODULE_DIR)
+				set(SOAPY_SDR_MODULE_DIR "lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
+			endif()
 		elseif(APPLE)
-			set(SOAPY_SDR_MODULE_DIR "/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
-		else()
-			# Linux - try common locations
-			foreach(POSSIBLE_DIR 
-				"/usr/lib/x86_64-linux-gnu/SoapySDR/modules${SoapySDR_ABI_VERSION}"
-				"/usr/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}"
-				"/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
+			# Try multiple paths on macOS
+			foreach(POSSIBLE_DIR
+				"/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}"
+				"/usr/local/lib/SoapySDR/modules0.8-3"
+				"/usr/local/lib/SoapySDR/modules0.8"
+				"/opt/homebrew/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
 				if(EXISTS "${POSSIBLE_DIR}")
 					set(SOAPY_SDR_MODULE_DIR "${POSSIBLE_DIR}")
 					break()
 				endif()
 			endforeach()
-			
-			# Final fallback
 			if(NOT SOAPY_SDR_MODULE_DIR)
-				set(SOAPY_SDR_MODULE_DIR "/usr/lib/x86_64-linux-gnu/SoapySDR/modules0.8")
+				set(SOAPY_SDR_MODULE_DIR "/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
+			endif()
+		else()
+			# Linux - try common locations with both ABI versions
+			# Order: source-built paths first (0.8-3), then system package paths (0.8)
+			foreach(POSSIBLE_DIR
+				"/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}"
+				"/usr/local/lib/SoapySDR/modules0.8-3"
+				"/usr/local/lib/SoapySDR/modules0.8"
+				"/usr/lib/x86_64-linux-gnu/SoapySDR/modules${SoapySDR_ABI_VERSION}"
+				"/usr/lib/x86_64-linux-gnu/SoapySDR/modules0.8-3"
+				"/usr/lib/x86_64-linux-gnu/SoapySDR/modules0.8"
+				"/usr/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}"
+				"/usr/lib64/SoapySDR/modules${SoapySDR_ABI_VERSION}")
+				if(EXISTS "${POSSIBLE_DIR}")
+					set(SOAPY_SDR_MODULE_DIR "${POSSIBLE_DIR}")
+					break()
+				endif()
+			endforeach()
+
+			# Final fallback - use detected ABI version with /usr/local prefix
+			if(NOT SOAPY_SDR_MODULE_DIR)
+				set(SOAPY_SDR_MODULE_DIR "/usr/local/lib/SoapySDR/modules${SoapySDR_ABI_VERSION}")
 			endif()
 		endif()
 		message(STATUS "SoapySDR module directory not auto-detected, using fallback: ${SOAPY_SDR_MODULE_DIR}")
-	else()
-		message(STATUS "Detected SoapySDR module directory: ${SOAPY_SDR_MODULE_DIR}")
 	endif()
 endif()
 
@@ -269,75 +330,3 @@
 		MACOSX_RPATH ON
 		INSTALL_RPATH_USE_LINK_PATH ON
 		# Remove problematic version properties for SoapySDR modules
-		VERSION ""
-		SOVERSION ""
-	)
-endif()
-
-# Add version compile definition
-target_compile_definitions(SoapyHydraSDR PRIVATE 
-	SOAPYHYDRASDR_VERSION="${SOAPYHYDRASDR_VERSION}"
-)
-
-# Ensure proper include paths for the target
-if(LibHYDRASDR_INCLUDE_DIRS)
-	# If headers are found in libhydrasdr subdirectory, we need to include the parent directory
-	if("${LibHYDRASDR_INCLUDE_DIRS}" MATCHES "libhydrasdr$")
-		# Headers are in libhydrasdr subdirectory, include the parent
-		get_filename_component(PARENT_INCLUDE_DIR "${LibHYDRASDR_INCLUDE_DIRS}" DIRECTORY)
-		target_include_directories(SoapyHydraSDR PRIVATE ${PARENT_INCLUDE_DIR})
-		message(STATUS "Adding parent include directory to target: ${PARENT_INCLUDE_DIR}")
-	else()
-		# Headers are in main include directory
-		target_include_directories(SoapyHydraSDR PRIVATE ${LibHYDRASDR_INCLUDE_DIRS})
-		message(STATUS "Adding include directory to target: ${LibHYDRASDR_INCLUDE_DIRS}")
-	endif()
-endif()
-
-# Installation rules
-install(TARGETS SoapyHydraSDR
-	LIBRARY DESTINATION ${SOAPY_SDR_MODULE_DIR}
-	ARCHIVE DESTINATION ${SOAPY_SDR_MODULE_DIR}  
-	RUNTIME DESTINATION ${SOAPY_SDR_MODULE_DIR}
-)
-
-# Verify module directory before installation
-if(NOT SOAPY_SDR_MODULE_DIR)
-	message(FATAL_ERROR "SoapySDR module directory not found. Cannot install module.")
-endif()
-
-message(STATUS "Will install SoapySDR module to: ${SOAPY_SDR_MODULE_DIR}")
-
-# On Windows, also install required DLLs
-if(WIN32)
-	# Use the same path calculation approach for consistency
-	get_filename_component(PROJECT_ROOT_DIR "${CMAKE_CURRENT_BINARY_DIR}" DIRECTORY)
-	set(RFONE_BUILD_DIR "${PROJECT_ROOT_DIR}/rfone_host_build/install")
-	
-	if(EXISTS "${RFONE_BUILD_DIR}/bin/hydrasdr.dll")
-		install(FILES "${RFONE_BUILD_DIR}/bin/hydrasdr.dll"
-			DESTINATION ${SOAPY_SDR_MODULE_DIR})
-		message(STATUS "Will install hydrasdr.dll from: ${RFONE_BUILD_DIR}/bin/")
-	endif()
-	
-	# Install other required Windows DLLs if they exist
-	file(GLOB WINDOWS_DLLS "${RFONE_BUILD_DIR}/bin/*.dll")
-	if(WINDOWS_DLLS)
-		install(FILES ${WINDOWS_DLLS} DESTINATION ${SOAPY_SDR_MODULE_DIR})
-		message(STATUS "Will install additional DLLs: ${WINDOWS_DLLS}")
-	endif()
-endif()
-
-# Print build information
-message(STATUS "")
-message(STATUS "Build Configuration Summary:")
-message(STATUS "  Project Version: ${SOAPYHYDRASDR_VERSION}")
-message(STATUS "  Build Type: ${CMAKE_BUILD_TYPE}")
-message(STATUS "  Compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
-message(STATUS "  Install Prefix: ${CMAKE_INSTALL_PREFIX}")
-message(STATUS "  SoapySDR Version: ${SoapySDR_VERSION}")
-message(STATUS "  SoapySDR ABI Version: ${SoapySDR_ABI_VERSION}")
-message(STATUS "  SoapySDR Module Dir: ${SOAPY_SDR_MODULE_DIR}")
-if(LibHYDRASDR_FOUND)
-	message(STATUS "  LibHYDRASDR Found: YES")
-else()
