=== debian/changelog ===
soapyhydrasdr (1.0.1-1) unstable; urgency=medium

  * New upstream release
  * update to v1.0.1-5-g77b6ae2
    reference new hydrasdr-host repository
  * Standards-Version: 4.7.3 (no changes)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 11 Feb 2026 21:36:13 -0500

soapyhydrasdr (0.1.0-3) unstable; urgency=medium

  * Team upload.
  * Set SOAPY_SDR_MODULE_DIR for multi-arch installation path.
    Thank you to Helmut Grohne for the fix and patch.  (Closes: #1123694)
  * Update d/copyright format URL
  * Remove Rules-Requires-Root from d/control

 -- tony mancill <tmancill@debian.org>  Mon, 22 Dec 2025 21:31:15 -0800
