=== debian/control ===
--- 
+++ 
@@ -7,8 +7,7 @@
 	       debhelper-compat (=13),
 	       libsoapysdr-dev,
 	       libhydrasdr-dev
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/hydrasdr/SoapyHydraSDR
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyhydrasdr.git
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/soapysdr/soapyhydrasdr
