=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DSOAPY_SDR_MODULE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/SoapySDR/modules0.8
